#!/bin/bash

export DQ2_LOCATION=`pwd`

wget -q http://atlas.web.cern.ch/Atlas/GROUPS/DATABASE/project/ddm/releases/scripts/install_dq2_sites.sh
sh install_dq2_sites.sh DQ2_0_1_4
#tar zcf /scratch2/users/atlas/dq2/dq2_sites.tar.gz .
#tar zxf /scratch2/users/atlas/dq2/dq2_sites.tar.gz

#wget -q http://atlas.web.cern.ch/Atlas/GROUPS/DATABASE/project/ddm/releases/scripts/post_install_dq2_sites.sh    # for now, use old saved version

mkdir -p post_install
cd agents
#mv BlockVerifier.py BlockVerifier.py.orig; mv Fetcher.py Fetcher.py.orig; mv Mover.py Mover.py.orig; 
cp -p ReplicaVerifier.py ReplicaVerifier.py.orig; cp -p ReplicaCatalog.py ReplicaCatalog.py.orig
cd ../conf
mv con_client_conf.py con_client_conf.py.orig; mv loc_client_conf.py loc_client_conf.py.orig; mv rep_client_conf.py rep_client_conf.py.orig
cd ../post_install

#mv BlockVerifier.py Fetcher.py Mover.py ReplicaVerifier.py ../agents

wget -q http://atlas.web.cern.ch/Atlas/GROUPS/DATABASE/project/ddm/releases/sites/`hostname -f`/site_conf.py
[ ! -f site_conf.py ] && cat site_conf.py.template | sed 's='"/opt/dq2"'='"$DQ2_LOCATION"'=' | sed 's='"ouhep00.nhn.ou.edu"'='`hostname -f`'=' > site_conf.py
#[ ! -f ../conf/site_conf.py ] &&   # for now, force using the current template:
mv site_conf.py ../conf
cd ..

sh post_install_dq2_sites.sh

rm -f $DQ2_LOCATION/certs/dq2.cert $DQ2_LOCATION/certs/dq2.key
#ln -f -s /etc/grid-security/hostcert.pem $DQ2_LOCATION/certs/dq2.cert
#ln -f -s /etc/grid-security/hostkey.pem $DQ2_LOCATION/certs/dq2.key

cd post_install
#[ ! -f ../conf/claims_server_conf.py ] && mv claims_server_conf.py ../conf/
#[ ! -f ../conf/claims_client_conf.py ] && mv claims_client_conf.py ../conf/
mv -f con_client_conf.py loc_client_conf.py rep_client_conf.py ../conf

cp -p ../agents/ReplicaVerifier.py ReplicaVerifier.py
cp -p ReplicaVerifier.py ReplicaVerifier.py.orig
cat ReplicaVerifier.py.orig | sed 's/'"procs = self.countProc()"'/'"procs = self.countProc() - 2"'/g' > ReplicaVerifier.py
mv -f ReplicaVerifier.py ../agents

cp -p ../agents/ReplicaCatalog.py ReplicaCatalog.py
cp -p ReplicaCatalog.py ReplicaCatalog.py.orig
numlines=`cat ReplicaCatalog.py | wc -l`
nummain=`expr $numlines - 8`
head -3 ReplicaCatalog.py.orig > ReplicaCatalog.py
tail -$nummain ReplicaCatalog.py.orig >> ReplicaCatalog.py
mv -f ReplicaCatalog.py ../agents

mv ../fts-client/fts-cli.sh ../fts-client/fts-cli.sh.orig
mv -f fts-cli.sh ../fts-client

#CRONTAB=dq2_crontab
#echo "export DQ2_LOCATION=$DQ2_LOCATION" > $CRONTAB
#which vobox-proxy > /dev/null 2>&1
#if [ $? = 0 ] ; then
#  echo "X509_USER_PROXY=`vobox-proxy --vo atlas query-proxy-filename`" >> $CRONTAB
#fi
#echo "PATH=$PATH" >> $CRONTAB
#echo "PYTHONPATH=$PYTHONPATH" >> $CRONTAB
#echo "LD_LIBRARY_PATH=$LD_LIBRARY_PATH" >> $CRONTAB
#echo "export PATH=\$DQ2_LOCATION/edg-gridftp-client/bin/:\$PATH" >> $CRONTAB
#echo "source \$DQ2_LOCATION/fts-client/fts-cli.sh" >> $CRONTAB
#cat agents.cron >> $CRONTAB

cat agents.cron.template | sed 's='"/opt/dq2"'='"$DQ2_LOCATION"'=g' > agents.cron

cat dq2.template | sed 's='"/opt/dq2"'='"$DQ2_LOCATION"'=' | sed 's='"atlas"'='"$USER"'=' > dq2
chmod +x dq2

cd ..
source setup.sh
./mysql.sh start
sleep 2
mysql --verbose -h `hostname` -u dq2user -pdqpwd <<EOF
use queuedtransfers;
alter table t_meta add (lastmodified blob);
insert into t_metaspec (colname, coltype) values 
('lastmodified','string');
quit
EOF
mysql --verbose -h `hostname` -u dq2user -pdqpwd <<EOF
use localreplicas;  
CREATE TABLE \`t_meta\` (
  \`guid\` varchar(40) binary NOT NULL default '',
  \`md5sum\` blob,
  \`fsize\` blob,
  PRIMARY KEY  (\`guid\`)
) TYPE=MyISAM;
CREATE TABLE \`t_metaspec\` (
  \`colname\` varchar(250) binary NOT NULL default '',
  \`coltype\` varchar(40) binary default NULL,
  PRIMARY KEY  (\`colname\`)
) TYPE=MyISAM;
INSERT INTO \`t_metaspec\` VALUES (0x6d643573756d, 0x737472696e67);
INSERT INTO \`t_metaspec\` VALUES (0x6673697a65, 0x737472696e67);
quit
EOF
./mysql.sh stop

mv setup.sh setup_dq2.sh
